/*
 * This file contains D-Bus adaptor classes generated by qt-svc-gen.py.
 *
 * This file can be distributed under the same terms as the specification from
 * which it was generated.
 */

#include <TelepathyQt/AbstractAdaptor>
#include <TelepathyQt/Global>
#include <TelepathyQt/Types>

#include <QObject>
#include <QtDBus>

namespace Tp
{
namespace Service
{

/**
 * \class DebugAdaptor
 * \headerfile TelepathyQt/_gen/svc-debug.h <TelepathyQt/_gen/svc-debug.h>
 * \ingroup servicecm
 *
 * Adaptor class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Debug".
 */
class TP_QT_EXPORT DebugAdaptor : public Tp::AbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.freedesktop.Telepathy.Debug")
    Q_CLASSINFO("D-Bus Introspection", ""
"  <interface name=\"org.freedesktop.Telepathy.Debug\">\n"
"    <property access=\"readwrite\" type=\"b\" name=\"Enabled\"/>\n"
"    <method name=\"GetMessages\">\n"
"      <arg direction=\"out\" type=\"a(dsus)\" name=\"messages\">\n"
"        <annotation value=\"Tp::DebugMessageList\" name=\"com.trolltech.QtDBus.QtTypeName.Out0\"/>\n"
"      </arg>\n"
"    </method>\n"
"    <signal name=\"NewDebugMessage\">\n"
"      <arg type=\"d\" name=\"time\"/>\n"
"      <arg type=\"s\" name=\"domain\"/>\n"
"      <arg type=\"u\" name=\"level\"/>\n"
"      <arg type=\"s\" name=\"message\"/>\n"
"    </signal>\n"
"  </interface>\n"
"")
    Q_PROPERTY(bool Enabled READ Enabled WRITE SetEnabled)

public:
    DebugAdaptor(const QDBusConnection& dbusConnection, QObject* adaptee, QObject* parent);
    virtual ~DebugAdaptor();

    typedef Tp::MethodInvocationContextPtr< Tp::DebugMessageList > GetMessagesContextPtr;

public: // PROPERTIES
    /**
     * Return the value of the exported D-Bus object property \c Enabled of type \c bool.
     *
     * Adaptees should export this property as a Qt property named
     * 'enabled' with type bool.
     *
     * 
     * TRUE if the NewDebugMessage signal should be emitted when a new debug 
     * message is generated.
     *
     * \return The value of exported property \c Enabled.
     */
    bool Enabled() const;
    /**
     * Set the value of the exported D-Bus object property \c Enabled of type \c bool.
     *
     * Adaptees should export this property as a writable Qt property named
     * 'enabled' with type bool.
     *
     * 
     * TRUE if the NewDebugMessage signal should be emitted when a new debug 
     * message is generated.
     */
    void SetEnabled(const bool &newValue);

public Q_SLOTS: // METHODS
    /**
     * Begins a call to the exported D-Bus method \c GetMessages on this object.
     *
     * Adaptees should export this method as a Qt slot with the following signature:
     * void getMessages(const Tp::Service::DebugAdaptor::GetMessagesContextPtr &context);
     *
     * Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError
     * accordingly) on the received \a context object once the method has finished processing.
     *
     * 
     * Retrieve buffered debug messages. An implementation could have a limit 
     * on how many message it keeps and so the array returned from this method 
     * should not be assumed to be all of the messages in the lifetime of the 
     * service.
     *
     * \return
     *     
     *     A list of debug messages.
     */
    Tp::DebugMessageList GetMessages(const QDBusMessage& dbusMessage);

Q_SIGNALS: // SIGNALS
    /**
     * Represents the exported D-Bus signal \c NewDebugMessage on this object.
     *
     * Adaptees should export this signal as a Qt signal with the following signature:
     * void newDebugMessage(double time, const QString& domain, uint level, const QString& message);
     *
     * The adaptee signal will be automatically relayed as a D-Bus signal once emitted.
     *
     * \param time
     *     
     *     Timestamp of the debug message.
     * \param domain
     *     
     *     Domain of the debug message, as described in the Debug_Message 
     *     struct.
     * \param level
     *     
     *     Level of the debug message.
     * \param message
     *     
     *     The text of the debug message.
     */
    void NewDebugMessage(double time, const QString& domain, uint level, const QString& message);
};

}
}